function TrNumberFormat(a0,a1)
{
if(!a0)
alert("type for TrNumberFormat not defined!");
this._type=a0;
this._localeSymbols=getLocaleSymbols(a1);
this._pPre=this._localeSymbols.getPositivePrefix();
this._pSuf=this._localeSymbols.getPositiveSuffix();
this._nPre=this._localeSymbols.getNegativePrefix();
this._nSuf=this._localeSymbols.getNegativeSuffix();
this._maxFractionDigits=3;
this._maxIntegerDigits=40;
this._minFractionDigits=0;
this._minIntegerDigits=1;
this._groupingUsed=true;
}
TrNumberFormat.getNumberInstance=function(a2)
{
return new TrNumberFormat("number",a2);
}
TrNumberFormat.getCurrencyInstance=function(a3)
{
return new TrNumberFormat("currency",a3);
}
TrNumberFormat.getPercentInstance=function(a4)
{
return new TrNumberFormat("percent",a4);
}
TrNumberFormat.prototype.setGroupingUsed=function(a5)
{
this._groupingUsed=a5;
}
TrNumberFormat.prototype.isGroupingUsed=function()
{
return this._groupingUsed;
}
TrNumberFormat.prototype.setMaximumIntegerDigits=function(a6)
{
if(a6)
{
this._maxIntegerDigits=a6<0?0:a6;
if(this._minIntegerDigits>this._maxIntegerDigits)
{
this._minIntegerDigits=this._maxIntegerDigits;
}
}
}
TrNumberFormat.prototype.getMaximumIntegerDigits=function()
{
return this._maxIntegerDigits;
}
TrNumberFormat.prototype.setMaximumFractionDigits=function(a7)
{
if(a7)
{
this._maxFractionDigits=a7<0?0:a7;
if(this._maxFractionDigits<this._minFractionDigits)
{
this._minFractionDigits=this._maxFractionDigits;
}
}
}
TrNumberFormat.prototype.getMaximumFractionDigits=function()
{
return this._maxFractionDigits;
}
TrNumberFormat.prototype.setMinimumIntegerDigits=function(a8)
{
if(a8)
{
this._minIntegerDigits=a8<0?0:a8;
if(this._minIntegerDigits>this._maxIntegerDigits)
{
this._maxIntegerDigits=this._minIntegerDigits;
}
}
}
TrNumberFormat.prototype.getMinimumIntegerDigits=function()
{
return this._minIntegerDigits;
}
TrNumberFormat.prototype.setMinimumFractionDigits=function(a9)
{
if(a9)
{
this._minFractionDigits=a9<0?0:a9;
if(this._maxFractionDigits<this._minFractionDigits)
{
this._maxFractionDigits=this._minFractionDigits;
}
}
}
TrNumberFormat.prototype.getMinimumFractionDigits=function()
{
return this._minFractionDigits;
}
TrNumberFormat.prototype.format=function(a10)
{
if(this._type=="percent")
return this.percentageToString(a10);
else if(this._type=="currency")
return this.currencyToString(a10);
else if(this._type=="number")
return this.numberToString(a10);
}
TrNumberFormat.prototype.parse=function(a11)
{
if(this._type=="percent")
return this.stringToPercentage(a11);
else if(this._type=="currency")
return this.stringToCurrency(a11);
return this.stringToNumber(a11);
}
TrNumberFormat.prototype.stringToNumber=function(a12)
{
if(isNaN(a12)||a12.indexOf('e')!=-1||a12.indexOf('E')!=-1)
{
throw new TrParseException("not able to parse number");
}
return parseFloat(a12);
}
TrNumberFormat.prototype.stringToCurrency=function(a13)
{
var a14=a13.indexOf(this._nPre);
if(a14!=-1)
{
a13=a13.substr(this._nPre.length,a13.length);
var a15=this._nSuf;
if(a15.charAt(0)==' '||a15.charAt(0)=='\xa0')
a15=a15.substring(1);
var a16=a13.indexOf(a15);
if(a16!=-1)
{
a13=a13.substr(0,a13.length-a15.length);
return(this.stringToNumber(a13)*-1);
}
else
{
throw new TrParseException("not able to parse number");
}
}
else
{
var a17=a13.indexOf(this._pPre);
if(a17!=-1)
{
a13=a13.substr(this._pPre.length,a13.length);
var a18=this._pSuf;
if(a18.charAt(0)==' '||a18.charAt(0)=='\xa0')
a18=a18.substring(1);
var a19=a13.indexOf(a18);
if(a19!=-1)
{
a13=a13.substr(0,a13.length-a18.length);
a13=this.stringToNumber(a13);
}
else
{
throw new TrParseException("not able to parse number");
}
return a13;
}
else
{
throw new TrParseException("not able to parse number");
}
}
}
TrNumberFormat.prototype.stringToPercentage=function(a20)
{
var a21=(a20.indexOf('%')!=-1);
if(!a21)
{
throw new TrParseException("not able to parse number");
}
var a22=a20.replace(/\%/g,'');
return this.stringToNumber(a22);
}
TrNumberFormat.prototype.numberToString=function(a23)
{
var a24=a23<0;
if(a24)
a23=(a23*-1);
var a25=a23+"";
var a26=a25.indexOf(".");
var a27=a25.length;
var a28;
var a29;
if(a26!=-1)
{
a28=a25.substring(0,a26);
a29=a25.substring(a26+1,a27);
}
else
{
a28=a25;
a29="";
}
a28=this._formatIntegers(a28);
a29=this._formatFractions(a29)
var a30=this._localeSymbols.getDecimalSeparator();
if(a29!="")
a25=(a28+a30+a29);
else
a25=(a28);
if(a24)
a25="-"+a25;
return a25;
}
TrNumberFormat.prototype.currencyToString=function(a31)
{
if(a31<0)
{
a31=(a31*-1)+"";
a31=this.numberToString(a31);
return this._nPre+a31+this._nSuf;
}
else
{
a31=this.numberToString(a31);
return this._pPre+a31+this._pSuf;
}
}
TrNumberFormat.prototype.percentageToString=function(a32)
{
a32=a32*100;
a32=this.getRounded(a32);
if(isNaN(a32))
{
throw new TrParseException("not able to parse number");
}
var a33=this._localeSymbols.getPercentSuffix();
if(!a33||a33=="")
{
throw new TrParseException("percent suffix undefined or empty");
}
a32=this.numberToString(a32);
return a32+a33;
}
TrNumberFormat.prototype.getRounded=function(a34)
{
a34=this.moveDecimalRight(a34);
a34=Math.round(a34);
a34=this.moveDecimalLeft(a34);
return a34;
}
TrNumberFormat.prototype.moveDecimalRight=function(a35)
{
var a36='';
a36=this.moveDecimal(a35,false);
return a36;
}
TrNumberFormat.prototype.moveDecimalLeft=function(a37)
{
var a38='';
a38=this.moveDecimal(a37,true);
return a38;
}
TrNumberFormat.prototype.moveDecimal=function(a39,a40)
{
var a41='';
a41=this.moveDecimalAsString(a39,a40);
return parseFloat(a41);
}
TrNumberFormat.prototype.moveDecimalAsString=function(a42,a43)
{
var a44=2;
if(a44<=0)
return a42;
var a45=a42+'';
var a46=this.getZeros(a44);
var a47=new RegExp('([0-9.]+)');
if(a43)
{
a45=a45.replace(a47,a46+'$1');
var a48=new RegExp('(-?)([0-9]*)([0-9]{'+a44+'})(\\.?)');
a45=a45.replace(a48,'$1$2.$3');
}
else
{
var a49=a47.exec(a45);
if(a49!=null)
{
a45=a45.substring(0,a49.index)+a49[1]+a46+a45.substring(a49.index+a49[0].length);
}
var a48=new RegExp('(-?)([0-9]*)(\\.?)([0-9]{'+a44+'})');
a45=a45.replace(a48,'$1$2$4.');
}
a45=a45.replace(/\.$/,'');
return a45;
}
TrNumberFormat.prototype.getZeros=function(a50)
{
var a51='';
var a52;
for(a52=0;a52<a50;a52++){
a51+='0';
}
return a51;
}
TrNumberFormat.prototype._formatIntegers=function(a53)
{
var a54=a53.length;
var a55=this.getMaximumIntegerDigits();
var a56=this.getMinimumIntegerDigits();
var a57;
if(a54>a55)
{
a57=a54-a55;
a53=a53.substring(a57,a54);
}
else if(a54<a56)
{
a57=a56-a54;
var a58="";
while(a57>0)
{
a58="0"+a58;
--a57;
}
a53=a58+a53;
}
if(this.isGroupingUsed())
{
a53=this._addGroupingSeparators(a53);
}
return a53;
}
TrNumberFormat.prototype._formatFractions=function(a59)
{
var a60=a59.length;
var a61=this.getMaximumFractionDigits();
var a62=this.getMinimumFractionDigits();
if(a60>a61&&a61>a62)
{
a59=a59.substring(0,a61);
}
if(a60<a62)
{
var a63=a62-a60;
while(a63>0)
{
a59=a59+"0";
--a63;
}
}
return a59;
}
TrNumberFormat.prototype._addGroupingSeparators=function(a64)
{
var a65=a64.length;
var a66=a65%3;
var a67;
var a68;
var a69="";
var a70=this._localeSymbols.getGroupingSeparator();
if(a66>0)
{
a67=(a65<4)?a64.substring(0,a66):a64.substring(0,a66)+a70;
a68=a64.substring(a66,a65);
}
else
{
a67="";
a68=a64;
}
for(i=0;i<a68.length;i++)
{
if(i%3==0&&i!=0)
{
a69+=a70;
}
a69+=a68.charAt(i);
}
a64=a67+a69;
return a64;
}
function TrParseException(
a0
)
{
this._message=a0;
}
TrParseException.prototype.getMessage=function()
{
return this._message;
}
